definition module CTBase

// *****************************************************
// Clean Texturing Library
// Copyright 2001 Jerzy Karczmarczuk, University of Caen
// Version 01.10
// *****************************************************
// Basic texture generators, combinators and transformers

import CTVector, CTFunalg, CTParams

rotated_cs :: !a !a v:(.(Vec2 !a)->.b) -> u:(.(Vec2 !a)->.b) | *,+,- a, [u<=v]
rotated :: !a -> .(v:(.(Vec2 !a)->.b) -> u:(.(Vec2 !a)->.b)) | *,+,-,cos,sin a, [u<=v]
transposed :: v:((Vec2 !a)->.b) -> u:((Vec2 !a)->.b), [u<=v]
rotated90 :: v:(.(Vec2 !a)->.b) -> u:(.(Vec2 !a)->.b) | ~ a, [u<=v]
rotated45 :: v:(.(Vec2 !Real) -> .a) -> u:((Vec2 !Real)->.a), [u<=v]
rotated60 :: v:(.(Vec2 Real) -> .a) -> u:((Vec2 .Real) -> .a), [u<=v]
reduced :: v:(.(Vec2 !a)->.b) -> u:(.(Vec2 !a)->.b) | -,fromInt,toReal a, [u<=v]
redscaled :: .(Vec2 !a) v:(.(Vec2 !a)->.b)->u:(.(Vec2 !a)->.b) | -,/,fromInt,toReal a, [u<=v]
symreduced :: .(!(Vec2 a)-> .b) !.(Vec2 a) -> .b | *,+,-,fromInt,half,one,toReal,two a
repliq :: !.Real -> .(v:(!(Vec2 a) -> .b) -> u:(!.(Vec2 a) -> .b)) 
          | *,+,-,/,fromInt,fromReal,half,one,toReal,two a,[u<=v]

rotatedAbout :: !.(Vec2 !a) !a -> .(v:((Vec2 a) -> .b) -> u:(.(Vec2 a) -> .b)) | *,+,-,cos,sin,~ a, [u<=v]

step :: !a -> a | < ,zero,half,one a
pulse :: !a -> a | <,one,zero,half a
xstep :: !a !a -> !a | <,half,one,zero a
xpulse :: !a !a !a -> !a | <,half,one,zero a
trainpulse :: !a -> !a | -,<,fromInt,half,one,toReal, zero a
symtrain :: (!a -> !b) !a -> !b | *,+,-,fromInt,half,one,toReal,two a
symteeth :: (!a -> !a) | *,+,-,abs,fromInt,half,one,toReal,two a

filteredabs :: !a !a -> a | *,+,/,<,half, ~ a
filteredpulse :: !a !a !a !a -> a | *,+,-,/,<,two,zero a
smoothstep :: !a !a -> .(a -> a) | *,-,/,<,one,three,two, zero a
hypulse :: !a !a !a -> .(a -> a) | *,+,-,/,<,one,zero a

unitdisk :: (a !b) -> !b | *,+,-,<,half,one,zero b & norm2 a
disk :: (a b) b (a b) -> b | <->,norm2 a & *,+,-,<,half,one,zero b

xstripe :: v:(!a -> .b) -> u:((Vec2 !a) -> .b), [u<=v]
ystripe :: v:(!a -> .b) -> u:((Vec2 !a) -> .b), [u<=v]
checkers :: !(Vec2 !a) -> !a | -,<,fromInt,half,one,toReal,zero a
chboard :: !(Vec2 !.Real) -> Real
polygon :: !.Int !.(Vec2 a) -> a | *,+,-,/,<,==,atan,cos,fromReal,sin,toReal,zero a
regstar :: !.Int !.Real !.Real -> !.(!(Vec2 !.Real) -> Real)
triangle :: !.(Vec2 a) !.(Vec2 a) !.(Vec2 a) -> .(!.(Vec2 !a) -> b) 
            | one,zero b & *,+,-,/,<,one,zero a

colmap :: [!.(a !b, !b)] .IMethod !b -> a !b | *>,<+> a & *,+,-,/,<,half,one,three,two,fromReal b

rotated3_cs :: !a !a !.(Vec3 a) v:(!(Vec3 a)-> .b)-> u:(!.(Vec3 a)-> .b) 
   | *,+,-,~a,[u<=v]
rotated3 :: !a !.(Vec3 a) v:(!(Vec3 a)-> .b)-> u:(!.(Vec3 a)-> .b) | *,+,-,cos,sin,~ a,[u<=v]
chboard3 :: !(Vec3 !.Real) -> Real





