definition module CTColour

// *****************************************************
// Clean Texturing Library
// Copyright 2001 Jerzy Karczmarczuk, University of Caen
// Version 01.10
// *****************************************************
// Basic colour routines, etc.

import CTGeneral, StdEnv
from StdPictureDef import Colour,RGBColour,RGB

:: RealCol a = {tr::a,tg::a,tb::a}
:: RealColour :== RealCol !Real
:: RColour :== RealCol !Real

instance zero (RealCol a) | zero a
instance one (RealCol a) | one a

instance fmap RealCol
instance *> RealCol
instance >/ RealCol
instance + (RealCol a) | + a
instance - (RealCol a) | - a
instance * (RealCol a) | * a
instance / (RealCol a) | / a
instance == (RealCol a) | == a

instance <+> RealCol
instance <-> RealCol
instance *>> (RealCol Real)

convertCol :: !(RealCol !Real) -> !Colour
iconvCol :: !Colour -> !RColour

blackRGB :: !Colour
whiteRGB :: !Colour
redRGB :: !Colour
greenRGB :: !Colour
blueRGB :: !Colour
yellowRGB :: !Colour
cyanRGB :: !Colour
magentaRGB :: !Colour


RRed :: RealCol !Real
RPink :: RealCol !Real
RDarkRed :: RealCol !Real
RLightRed :: RealCol !Real
RGreen :: RealCol !Real
RDarkGreen :: RealCol !Real
RLightGreen :: RealCol !Real
RBlue :: RealCol !Real
RBlack :: RealCol !Real
RWhite :: RealCol !Real
RCyan :: RealCol !Real
RDarkCyan :: RealCol !Real
RYellow :: RealCol !Real
RLightYellow :: RealCol !Real
RMagenta :: RealCol !Real
RGold :: RealCol !Real
RLightGold :: RealCol !Real
RDarkBlue :: RealCol !Real
RLightBlue :: RealCol !Real
RGrey :: RealCol !Real
RLightGrey :: RealCol !Real
RDarkGrey :: RealCol !Real
RDarkBrown :: RealCol !Real
RBrown :: RealCol !Real
RLightBrown :: RealCol !Real

:: CColour a :== (a -> RealCol !Real)
CWhite :: CColour a
CBlack :: CColour a
CRed :: CColour a
CDarkRed :: CColour a
CBlue :: CColour a
CDarkBlue :: CColour a
CGreen :: CColour a
CDarkGreen :: CColour a
CYellow :: CColour a
CCyan :: CColour a
CMagenta :: CColour a
CGrey :: CColour a
CLightGrey :: CColour a
CDarkGrey :: CColour a
CGold :: CColour a
CBrown :: CColour a

mkgrey :: !Real -> Colour
saturmul :: !(RealCol !a) -> !(RealCol a) | zero,==,/,< a
lighten :: !(RealCol !a) -> !(RealCol a) | one,==,+,-,< a

lumin :: !(RealCol !Real) -> Real
rgbtohsv :: (RealCol !Real) -> (Real,Real,Real)
hsvtorgb :: !Real !Real !Real -> RealCol Real






