implementation module CTFunalg

// *****************************************************
// Clean Texturing Library
// Copyright 2001 Jerzy Karczmarczuk, University of Caen
// Version 01.10
// *****************************************************
// Function algebra and some generic "DSP" primitives, useful
//  not only for textures.

import StdBool, StdFunc, CTGeneral

instance + (a -> b) | + b
where
 (+) f g = \x -> f x + g x
instance - (a -> b) | - b
where
 (-) f g = \x -> f x - g x
instance * (a -> b) | * b
where
 (*) f g = \x -> f x * g x
instance / (a -> b) | / b
where
 (/) f g = \x -> f x / g x
instance ~ (a -> b) | ~ b
where
 ~ f = \x -> ~(f x)
instance zero (a->b) | zero b
where
 zero = \_ -> zero
instance one (a->b) | one b
 where
 one = \_ -> one
instance two (a->b) | two b
 where
 two = \_ -> two
instance three (a->b) | three b
 where
 three = \_ -> three
instance half (a->b) | half b
 where
 half = \_ -> half
instance abs (a->b) | abs b
where
 abs f = \x -> abs (f x)

instance fromReal (a->b) | fromReal b
where
  fromReal c = \_ -> fromReal c
instance fromInt (a->b) | fromInt b
where
  fromInt c = \_ -> fromInt c
  
// I cannot make (a->) an instance of *> !!!
(*-) infixr 7 :: !b (a->b) -> (a->b) | * b
(*-) x f = \y -> x*(f y)

(*->) infixr 7 :: w:(a -> b) v:(a -> c b) -> u:(a -> c b) | *> c & * b,[u<=v,u<=w]
(*->) f t = \p -> f p *> t p

minf :: w:(a -> b) v:(a -> b) -> u:(a -> b) | < b, [u<=v,u<=w]
minf f g = \x -> min (f x) (g x)
maxf :: w:(a -> b) v:(a -> b) -> u:(a -> b) | < b, [u<=v,u<=w]
maxf f g = \x -> max (f x) (g x)
posit :: v:(.a -> b) -> u:(.a -> b) | <,zero b,[u<=v]
posit f = max zero o f

// Transformer functionals (generic)
translated :: !a .(!a -> .b) !a -> .b | - a
translated a f x = f (x-a)
scaled :: !a v:(a->.b) -> u:(a->.b) | /a,[u <=v]
scaled c f = \x -> f (x/c)
transf :: w:(.a->.b) v:(.b->.c) -> u:(.a->.c), [u<=v,u<=w]
transf fun txtr = \p -> txtr (fun p)
displace :: .(!a->a) .(!a->.b) !a -> .b | + a
displace dspl tx p = tx (p+dspl p)

clamp :: !a !a !a -> a | < a
clamp a b x = max a (min b x)
ramp :: .(!a -> a) | < , one , zero a
ramp = clamp zero one
fmask :: x:(!a->b) w:(!a->.c) v:(!a->.c)->u:(!a->.c) | ==,zero b,[u<=v,u<=w,u<=x]
fmask h f g = \x -> cmask (h x) (f x) (g x)
train :: .(!a->.b) !a -> .b | -,fromInt,toReal a
train f x = f (gfrac x)

