definition module CTMapping

// *****************************************************
// Clean Texturing Library
// Copyright 2001 Jerzy Karczmarczuk, University of Caen
// Version 01.10
// *****************************************************
// Basic transformations, deformations, 3D mappings...

import CTBase, CTView
import StdMaybe

trfshift :: !a .(!a -> a) !a -> a | + , - a
trftranslate :: !a-> .(x:(!a->a)->u:(w:(!a-> .b)->v:(a-> .b))) | +,- a, [v<=w,v u<=x]

trfturn :: !a v:(!.(Vec2 !a)-> .Vec2 a) -> u:(!.(Vec2 !a) -> .Vec2 a) | *,+,-,cos,sin,~ a, [u<=v]

whirl :: !a !a !.(Vec2 !a)->.Vec2 a | *,+,/,<,==,atan,cos,exp,fromReal,sin,sqrt,zero,~ a
vortex :: !a !a !a !.(Vec2 !a) -> Vec2 a | *,+,-,/,<,cos,sin,sqrt a
lense :: a a a -> .(.(Vec2 a) -> Vec2 a) | *,+,-,/,<,one,sqrt,zero,~ a

spherepoint :: !.Viewscreen -> .(!.RVec2 -> (.Bool,RVec3,RVec3,RVec3))
cubepoint :: !.Viewscreen -> .(!.RVec2 -> (Bool,RVec3,RVec3,RVec3))
cylinderpoint :: !.Viewscreen -> .(.RVec2 -> (.Bool,RVec3,RVec3,RVec3))

proj_plane :: !.(Vec3 a) !a !.(Vec3 a) v:(!(Vec3 a) -> .b) -> u:(!.(Vec2 a) -> .b) 
            | *,+,-,/,sqrt a,[u<=v]

bumped :: RVec3 (RVec3-> .Real) .(RVec3 -> .(RVec3 -> .(.a -> b Real))) 
          (Vec3 .Real) (Vec3 .Real) .a -> b Real | *> b
