definition module CTRandom

// *****************************************************
// Clean Texturing Library
// Copyright 2001 Jerzy Karczmarczuk, University of Caen
// Version 01.10
// *****************************************************
// Ergodic primitives, noise, etc.

import CTGeneral, CTVector

rand0 :: !Int -> (!Real,!Int)
rand1 :: !Int -> (!Real,!Int)
rand0_h :: !Int -> (!Real,!Int)
rand1_h :: !Int -> (!Real,!Int)
rand0_s :: !Int -> (!Real,!Int)
rand1_s :: !Int -> (!Real,!Int)

randn0 :: !.Int -> (Real,Int)
randn1 :: !.Int -> (Real,Int)

ergodic :: !Int -> !Real
ergodic_s :: !Int -> !Real   //  in [-1 : 1]
ergxy :: !Int !Int -> !Real
ergxy_s :: !Int !Int -> !Real
ergxy2_s :: !Int !Int -> !(!Real,!Real)

rgxy :: .Int .Int a a -> a | *,+,cos,fromReal,sin a

ergvecxy :: !Int !Int !Real !Real -> Real   // gen. in [-1 - 1]

grnoise2 :: !.(Vec2 a) -> a | *,+,-,cos,fromInt,fromReal,one,sin,toReal a
noise2 :: !.(Vec2 a) -> a | *,+,-,<,cos,fromInt,fromReal,one,sin,toReal,zero a
ergxyz :: !Int !Int !Int -> Real
ergnoise3 :: !Int !Int !Int -> !(Vec3 !Real)
ergvecxyz :: !Int !Int !Int !(Vec3 !Real) -> Real
grnoise3 :: !(Vec3 !Real) -> Real

ergnoise2 :: !.Int !.Int -> Vec2 Real
vecnoise2 :: !(Vec2 .Real) -> Vec2 Real

fractsum :: ((a !Real) -> !b) (a !Real) !Int !Real !Real -> .((a !Real) -> !b) | *>>,+,zero b & *>,<+>,vzero a
fractsum2 :: (!Int -> (!Real -> (!Real -> (!RVec2 -> !Real))))
//turbulence2 :: (!Int -> (!Real -> (!Real -> (!RVec2 -> !Real))))
fractsum3 :: (!Int -> (!Real -> (!Real -> (!RVec3 -> !Real))))
turbulence3 :: (!Int -> (!Real -> (!Real -> (!RVec3 -> !Real))))
vecnoise3 :: !RVec3 -> !RVec3

//

gennoise2 :: !.(Vec2 a) -> a | *,+,-,cos,fromInt,fromReal,one,sin,toReal a
frsum :: ((a !b) -> c) (a !b) !.Int !.Real !b -> .((a !b) -> c) | *>>,+,zero c & *>,<+>,vzero a & *,+,fromReal,zero b
fractnoise2 :: (!.Int->v:(!.Real->u:(!a -> .(!.(Vec2 a)->a)))) 
               | *,*>>,+,-,cos,fromInt,fromReal,one,sin,toReal,zero a,[u<=v]
turbulence2 :: (!.Int->v:(!.Real->u:(!a -> .(!.(Vec2 a)->a)))) 
               | *,*>>,+,-,abs,cos,fromInt,fromReal,one,sin,toReal,zero a, [u<=v]







