definition module CTTile

// *****************************************************
// Clean Texturing Library
// Copyright 2001 Jerzy Karczmarczuk, University of Caen
// Version 01.10
// *****************************************************
// Non-cartesian lattice reduction, symmetries.

import CTVector,CTMapping

T2axis :: !RVec2
U2axis :: !RVec2

:: UnitCell = {axS::!RVec2,axT::!RVec2,st_dot::!Real,st_cross::!Real,
               norms2::!Real,normt2::!Real,
               norms::!Real,normt::!Real,
               vec_st::!RVec2-> !RVec2,st_vec::!RVec2-> !RVec2,
               red_st::!RVec2-> !RVec2,
               st_uv::!RVec2-> !RVec2,uv_st::!RVec2-> !RVec2,
               reduce::!RVec2-> !RVec2}
mkunitcell :: !.RVec2 !.RVec2 -> !.UnitCell
Tricell :: !UnitCell

tile_p1 :: !.UnitCell !.(RVec2 -> !.a) !.RVec2 -> !.a
tileMR_p1 :: !.UnitCell .(!RVec2 -> !.RVec2) .(!RVec2 -> .a) !.RVec2 -> .a
hextex :: !.UnitCell !.Real !.RVec2 !.RVec2 w:(RVec2-> .a) v:(RVec2-> .a)-> 
          u:(!.RVec2 -> .a), [u<=v,u<=w]
regular_hex :: v:(y:(!RVec2-> .a)-> u:(x:(!RVec2-> .a)-> w:(!.RVec2-> .a))), [w<=x,u w<=y,u<=v]
brickwall :: !.Real !.Real !.Real-> v:(y:(!RVec2-> .a)-> u:(x:(RVec2-> .a)-> 
             w:(!.RVec2-> .a))), [w<=x,u w<=y,u<=v]

p3reduce :: v:(!RVec2-> .a)-> u:(!.RVec2-> .a), [u<=v]









