definition module CTVector

// *****************************************************
// Clean Texturing Library
// Copyright 2001 Jerzy Karczmarczuk, University of Caen
// Version 01.10
// *****************************************************

import CTGeneral, CTFunalg

:: Vec3 a = V3 !a !a !a
:: RVec3 :== Vec3 Real
instance zero (Vec3 a) | zero a
instance one (Vec3 a) | one a
instance half (Vec3 a) | half a

instance fromReal (Vec3 a) | fromReal a

instance + (Vec3 a) | + a
instance ~ (Vec3 a) | ~ a
instance - (Vec3 a) | - a
instance * (Vec3 a) | * a
instance / (Vec3 a) | / a
instance == (Vec3 a) | == a

instance Show (Vec3 a) | Show a

instance fmap Vec3
instance *> Vec3
instance >/ Vec3
instance <.> Vec3
instance norm2 Vec3
instance <+> Vec3
instance <-> Vec3
instance vzero Vec3
instance *>> (Vec3 Real)
(/\) infix 9 :: !(Vec3 !a) !(Vec3 !a) -> Vec3 !a | -,* a

X3axis :: Vec3 !Real
Y3axis :: Vec3 !Real
Z3axis :: Vec3 !Real

tospher :: !.(Vec3 !a) -> Vec3 a | *,+,/,<,==,acos,atan,fromReal,sqrt,zero a
fromspher :: !.(Vec3 !a) -> Vec3 a | *,==,cos,sin,zero a
rot3_cs :: !a !a !.(Vec3 !a) !.(Vec3 !a) -> Vec3 a | *,+,- a
rot3 :: !a -> .(!.(Vec3 !a) -> .(!.(Vec3 !a) -> Vec3 a)) | *,+,-,cos,sin a
findrot :: !.(Vec3 a) !.(Vec3 a)-> .(!a,!a,!(Vec3 a)) | *,+,-,/,sqrt a


// ************************************************************

:: Vec2 a = V2 !a !a
:: RVec2 :== Vec2 !Real
instance zero (Vec2 a) | zero a
instance one (Vec2 a) | one a
instance half (Vec2 a) | half a
instance fromReal (Vec2 a) | fromReal a

instance ~ (Vec2 a) | ~ a
instance + (Vec2 a) | + a
instance - (Vec2 a) | - a
instance * (Vec2 a) | * a
instance / (Vec2 a) | / a
instance == (Vec2 a) | == a

instance Show (Vec2 a) | Show a

instance fmap Vec2
instance *> Vec2
instance >/ Vec2
instance <.> Vec2
instance norm2 Vec2
instance <+> Vec2
instance <-> Vec2
instance vzero Vec2

instance *>> (Vec2 Real)

X2axis :: Vec2 !Real
Y2axis :: Vec2 !Real

angle :: .(Vec2 a) -> a | +,/,<,==,atan,fromReal,zero a

skew :: !(Vec2 !a) !(Vec2 !a) -> a | * , - a
decomp2 :: !.(Vec2 !a) !.(Vec2 !a) !.(Vec2 !a) -> .(a,a) | *,-,/ a
rot2cs :: !a !a .(Vec2 !a) -> .Vec2 a | * , + , - a
rot2 :: !a !.(Vec2 !a) -> !.(Vec2 !a) | * , + , - , cos , sin a
rot90 :: !.(Vec2 !a) -> !.(Vec2 !a) | ~ a
refl :: !(Vec2 a) !(Vec2 a) !(Vec2 a) -> !(Vec2 a) | *,+,-,two a

toPolar :: !(Vec2 !a) -> !(a,a) | *,+,/,<,==,atan,fromReal,sqrt,zero a
lineq2 :: (.(Vec2 !a),.(Vec2 !a)) .(Vec2 !a) -> .Vec2 a | *,-,/ a

:: Ray a = Ray !(Vec3 !a) !(Vec3 !a)    // (x0,u) ::: x=x0 + t*>u
sscaled :: a .((b a) -> .c) (b a) -> .c | >/ b & / a

ldiffuse :: (a Real) .Real .((a Real) -> b) (a Real) (a Real) -> b | *>> b & <->,<.> ,>/,norm2 a
lstToVec3 :: !u:[.a] -> (Vec3 .a,v:[.a]), [u<=v]
reducevec :: !(Vec2 .Real) -> (Int,Int,.Vec2 Real)

fgrad3 :: !a (v:(Vec3 !a) -> !a) u:(Vec3 !a) -> .Vec3 a | +,-,/ a, [u<=v]
fgrad2 :: !a (v:(Vec2 !a) -> a) u:(Vec2 !a) -> .Vec2 a | +,-,/ a, [u<=v]
fbumpshade :: !(Vec3 .Real) !.Real !(v:RVec2 -> .Real) !u:(Vec2 .Real) -> Real,[u<=v];








