definition module CTView

// *****************************************************
// Clean Texturing Library
// Copyright 2001 Jerzy Karczmarczuk, University of Caen
// Version 01.10
// *****************************************************
// Primitive tools for interfacing.

import CTVector, StdEnv, StdIOBasic, CTColour

:: Texture a = T2 ((Vec2 !a) -> RealColour) | 
               T3 ((Vec3 !a) (Vec3 !a) (Vec3 !a) -> RealColour)
:: Light = {lpos::!RVec3, lcolour::RColour,spotAt::!RVec3,
            perpAtten::!Real-> !Real, distAtten::!Real-> !Real}
:: Viewport     = {width::!Int,height::!Int,
                   xmin::!Real,xmax::!Real,ymin::!Real,ymax::!Real,
                   xscale::!Real,yscale::!Real, vpix::(!RVec2->Point2),
                   vpix_0::(!RVec2->Point2),pixv::(!Point2-> !RVec2),
                   vxix::!Real-> !Int,vyiy::!Real -> !Int,
		   ixvx::!Int-> !Real,iyvy::!Int-> !Real,
                   vyiy_0::!Real -> !Int, iyvy_0::!Int-> !Real,
                   intfract::(!RVec2 -> !(!Int,!Real,!Int,!Real))
                  }

mkvport :: !Int !Int !Real !Real !Real !Real -> !Viewport
bmapPort :: !.Int !.Int !.Real !.Real -> Viewport

:: Camera = {pos::!RVec3, look_at::!RVec3,focal::!Real,rad::!Real,up::!RVec3,
             look_dir::!RVec3,axx::!RVec3,axy::!RVec3,
             orig::!RVec3,nrpos::!Real,dist::!Real}

mkcamera :: !.(Vec3 !Real) !.(Vec3 !Real) !.Real !.(Vec3 !Real) -> .Camera

readDib :: !*File -> (.Bool,(Int,Int,.{#Char}),.File)
readBmp :: !{#.Char} *a -> *((!Int,!Int,.{#Char}),*a) | FileSystem a
writeBmp :: {#.Char} {#.Char} *a -> *a | FileSystem a

setPixel :: !*{#Char} !Int !(RealCol !Real) -> !*{#Char}
makeDib :: !.Viewport (!(Vec2 !Real) -> RealCol !.Real) -> (!Int,!Int,!.{#Char})

aalias :: !Viewport (!(Vec2 !Real) -> !a) -> (!(Vec2 !Real) -> !a) | *>>,+ a
getPixel :: !(.Bool,.Bool) !{#.Char} -> v:(.Int -> u:(.Int -> (.Bool,RColour))), [u<=v]
bmapToTx :: !.Viewport !.IMethod !(.Bool,.Bool) !{#.Char} (RealCol .Real)-> .(.RVec2 -> RColour)
makebmaptx :: !{#.Char} (RealCol .Real) !(.Bool,.Bool) !.Real !.Real *a -> 
              *(.(.RVec2 -> RealCol Real),*a) | FileSystem a
:: Viewscreen      
   ={cam::!Camera, vport::!Viewport,midx::!Real,midy::!Real,
     project::!RVec3 -> !RVec2, ray::!RVec2 -> !RVec3,
     lights::(!RColour,[Light]),background :: !RVec2 -> !RColour}

mkview :: !.(Vec3 Real) !.(Vec3 Real) !.Real !.(Vec3 Real) !.Int !.Int -> .Viewscreen  
mkvscreen :: !.Camera !.Int !.Int -> .Viewscreen
addlights :: !.Viewscreen ((Vec2 !Real) -> .RealCol Real) .(RealCol Real) [.Light] -> .Viewscreen
mklight :: !.(Vec3 Real) !.(Vec3 Real) .(RealCol Real) (Real -> .Real) (Real -> .Real) -> .Light
lightview :: ((Vec2 !Real) -> RealCol .Real) !.Viewscreen !.Real (Vec3 !.Real) -> .Viewscreen
diffuselight :: !.Light (Vec3 !.Real) (Vec3 !.Real) -> Real
solidtx :: !.(Viewscreen -> .(RVec2 -> (.Bool,RVec3,RVec3,RVec3))) 
   !.Viewscreen !.Bool .(RVec3-> .(RVec3 RVec3 -> .RColour)) 
   !.RVec2 -> RColour






