module example1

// *****************************************************
// Clean Texturing Library
// Copyright 2001 Jerzy Karczmarczuk, University of Caen
// Version 01.10
// *****************************************************
// Your second set of examples. A more involved interface.
//  (But don't expect anything fabulous...)

import CTexture

Start :: *World -> *World
Start world = Render world

// Opens a multi-document interface
Render =: txdialog textureset



// Some auxiliary functions
rfun0 v 
  # (r,phi) = toPolar v
  = fromReal 1.2 + cos (fromReal 9.0 * phi) - r
rfun =: sscaled (fromReal 0.4) rfun0
rf4 =: gfrac o (fromReal 10.0 * grnoise2)
rf5 =: turbulence2 6 0.8 1.0
rf6 p = 1.0-exp((-4.5)*max zero (rf5 p - 0.25))

// This generates a set of functions (and descriptive strings) for the interface
// It uses the external environment in order to be able to open files, etc.
textureset world
 // Checkerboard
 # mfun1 = interpol RCyan RGold Linear o (sscaled 0.4 (rotated 0.2 checkers))

 // Flower: interior
 # mfun2 = interpol RRed RBlack Linear o (step o rfun)

 // Flower: contour
 # mfun3 = interpol RBlue RWhite Linear o (contour 0.03 rfun)

 // Isolines of a simple noise
 # mfun4 = colmap [(RGreen,0.0),(RRed,0.5),(RWhite,1.0)] Hermite o rf4

 // Turbulent noise + crazy colour map
 # mfun5 = colmap [(RRed,0.0),(RYellow,0.3),(RGreen,0.4),(RBlue,0.55),
                   (RMagenta,0.65),(RWhite,1.0)] Linear o rf5

 // nonlinear trf. of the turbulent noise
 # mfun6 = interpol RBlue RWhite Linear o rf6

 // An external image transformed into texture
 # ((w,h,bmap),world) = readBmp "../Images/zosia1.bmp" world
 # port = bmapPort w h (-0.5) 0.7 // Specif. virtual size, but keep proportions
 # imfun = bmapToTx port Linear (False,False) bmap RGrey

 // This is the texture function
 # mfun7 = rotated 0.2 imfun
 # funlist = [("Chessboard",T2 mfun1),("Flower",T2 mfun2),("Fl. contour",T2 mfun3),
              ("Col. noise",T2 mfun4),("Turbul.",T2 mfun5),("Clouds",T2 mfun6),
              ("Rot. im.",T2 mfun7)]
 = (funlist,world)
       
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!









