module example2

// *****************************************************
// Clean Texturing Library
// Copyright 2001 Jerzy Karczmarczuk, University of Caen
// Version 01.10
// *****************************************************
// More 2D examples. The same interface as previously. but
//   we import an additional module CTExamples with some
//   specific stuff.

import CTExamples

Start :: *World -> *World
Start world = Render world

// Opens a multi-document interface
Render =: txdialog textureset


// Some auxiliary functions

// Weaving game.
bkg = CGrey
hcols =: [CYellow,CRed,CBlue]
vcols =: [CGreen,CMagenta,CGold,CWhite]

test_intl =: modinterlace (3,2,3)
// 3 similar examples of weaving patterns
wexample0 = sscaled 0.3 (weave hcols 0.9 vcols 0.9 bkg simple_intl 0.4) 
wexample1 = sscaled 0.3 (weave hcols 0.9 vcols 0.9 bkg test_intl 0.4)
wexample2 = sscaled 0.3 (weave hcols 0.9 vcols 0.9 bkg tartan_intl 0.4)


// Two examples of Tartans.
// (76)
settG =: [(RBlack,6),(RRed,24),(RBlack,6),(RYellow,2),(RBlack,4),(RWhite,2),
           (RBlue,8),(RGreen,10),(RRed,6),(RBlack,2),(RRed,4),(RWhite,2)]
// (94)
settK =: [(RGreen,8),(RRed,8),(RBlack,4),(RRed,24),(RDarkCyan,2),(RBlack,14),
           (RRed,4),(RGreen,20),(RRed,6),(RBlack,4)]
tartanG=:mksett True settG
tartanK=:mksett True settK

texampleG = sscaled (1.0/152.0) (weave tartanG 1.0 tartanG 1.0 CGrey tartan_intl 0.0)
texampleK = sscaled (1.0/188.0) (weave tartanK 1.0 tartanK 1.0 CGrey tartan_intl 0.0)

// ==============================================

// Some noise transformations.
// Noise rendered through a colour map
wnoise p 
  # r = 12.0 * noise2 p
  = interpol RDarkBrown RLightBrown Hermite (gfrac r)

// Truchet pattern
trfun = sscaled (0.2) truchet


// See "dither" and "makegreybmap" in CTExamples


// Fractal noises and turbulence

fnoise0 =: fR 0.6 * (fractnoise2 6 (fR 0.8) (fR 1.0) + fR 0.8)
fnoise =: cmix RGreen RDarkBlue fnoise0 // (ramp o fnoise0)

tnoise0 =: fR 0.9 * turbulence2 6 (fR 0.8) (fR 1.0)
tnoise = cmix RYellow RRed tnoise0 // (ramp o tnoise0)

// Show this as relief
light = normalize (V3 (-0.7) (1.1) 3.0)
frelief0 = bumpshade light (fR 0.5 * fnoise0)
frelief = cmix RBlack RWhite frelief0

trelief0 = ramp o bumpshade light (fR 0.7 * tnoise0)
trelief = cmix RBlack RWhite trelief0
 
// Random placement of stars
star0 p = regstar 5 0.15 0.4 (p-(V2 0.5 0.5))
stars0 = (translated (V2 10.0 4.0) o bombing 0.4) star0
stars = cmix RDarkBlue RGold stars0

// This generates a set of functions (and descriptive strings) for the interface
textureset world

 // An external image transformed into texture
 # (whbmap,world) = readBmp "../images/natalia1.bmp" world
 # dithtx = dither 1215.0 (makegreybmap whbmap)
 
 # funlist = [("Simple", T2 wexample0),
              ("Weave1/2", T2 wexample1),
              ("Scottish", T2 wexample2),
              ("Tartan 1", T2 texampleG),
              ("Tartan 2", T2 texampleK),
              ("Wood noise",T2 wnoise),
              ("Truchet", T2 trfun),
              ("Dither", T2 dithtx),
              ("Fract. noise", T2 fnoise),
              ("Turbulence", T2 tnoise),
              ("Fract. relief", T2 frelief),
              ("Turb. relief", T2 trelief),
              ("Stars", T2 (sscaled 0.3 stars))
             ]
 = (funlist,world)
   
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!







