module example5

// *****************************************************
// Clean Texturing Library
// Copyright 2001 Jerzy Karczmarczuk, University of Caen
// Version 01.10
// *****************************************************
// Tilings

import CTExamples

Start :: *World -> *World
Start world = Render world

// Opens a multi-document interface
Render =: txdialog textureset

// Some auxiliary functions
// An asymmetric motif to visualize the symmetry
motif
  = translated (V2 (-0.1) (-0.1))
      (trftranslate (V2 0.3 0.3) (whirl 10.0 12.0) (sscaled 0.5 unitdisk))
// Background and superposed motif
bands=:colmap [(RRed,0.0),(RLightBlue,0.4),(RWhite,0.6),(RYellow,1.0)] Linear o symteeth
bground  = (sscaled 0.5 o rotated 0.3 o xstripe) bands
bgroundd = sscaled 0.1 (bands o norm)         // if you prefer concentric circles
tmotif p = cmask (motif p) RBlack (bground p)  // add "d" to bground here

// Hex patterns
// Arbitrary
hgons 
  =: hextex (mkunitcell X2axis (0.2*>X2axis+0.7*>Y2axis)) 0.03
         (V2 0.4 0.3) (V2 0.6 0.7) 
         (sscaled 0.5 tmotif) CDarkGrey

//Regular beehive
regtest = sscaled 0.67 (regular_hex (cmix RBrown RLightGreen (sscaled 0.3 noise2))
                                    CBlack)

// Brick wall topology
britx = sscaled 0.16 (cmix RDarkBrown RGold (translated (V2 2.2 8.9) noise2))
morx =: sscaled 0.01 (cmix RWhite RBlack noise2) 
brictest = brickwall 0.8 0.35 0.03 britx morx

// =========================

// Symmetry P3
testp3 =: sscaled 0.67 (p3reduce (translated (V2 0.0 0.2) bgroundd))

// Kaleidoscope. P3ml
kalmotif =: translated (V2 0.67 0.55) (sscaled 0.25 tmotif)  

// Parquet. PGG/PG
ngrain =: scaled (V2 0.6 0.006)
  (cmix RBlack RLightBrown (translated (V2 7.2 1.1) noise2))
deform = displace (fR 0.01 * frsum vecnoise2 (V2 2.8 1.3) 3 0.8 3.0)
txparq =:deform ngrain
   
a=:0.68;  b=:0.18
tparquet =: parquet a b txparq

// This generates a set of functions (and descriptive strings) for the interface
textureset world
 // Escher reptiles; You can't change "Yellow", it is the bg mask colour...
 # (lizard0,world) = makebmaptx "../Images/reptil.bmp" RYellow (False,False)
                    0.0 1.5 world
 # lizard = translated (V2 0.0 (-0.5/Sqrt3)) lizard0
 # kallizard = (translated (V2 (0.37) (0.45)) (sscaled 0.36 lizard))
 # funlist = [("Motif",T2 tmotif),
              ("Hexagons",T2 hgons),
              ("Beehive",T2 regtest),
              ("Bricks",T2 brictest),
              ("P3 pattern",T2 testp3),
              ("Lizards",T2 (sscaled 0.5 (txmotifp3 lizard RYellow))),
              ("Kaleidoscope",T2 (sscaled 0.6 (kaleidoscope kalmotif))),
              ("Liz' dance",T2 (kaleidoscope kallizard)),
              ("Wood grain",T2 txparq),
              ("Parquet",T2 tparquet)
             ]
 = (funlist,world)
     
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


